{+--------------------------------------------------------------------------+
 | Component:   TmwComboStrGrid
 | Created:     05.98 with help of Arabella by Thomas Quester
 |              Give it a try. http://members.tripod.com/~Arabella_fairy/
 | Author:      Martin Waldenburg
 | Copyright    1998, all rights reserved.
 | Description: Study on how to create a ComboBox like Component
 | Status:      FreeWare
 | Version:     1.0
 | DISCLAIMER:  This is provided as is, expressly without a warranty of any kind.
 |              You use it at your own risc.
 +--------------------------------------------------------------------------+}
unit mwCombStrGrid;



interface

uses
  Windows, SysUtils, Messages, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls, Buttons, Commctrl, Grids;

type
  TmwComboStrGrid = class;

  TmwScreenStrGrid = class(TStringGrid)
  private
    FMouseInControl: Boolean;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure WMMouseMove(var Message: TWMMouseMove); message WM_MOUSEMOVE;
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
  public
    constructor Create(AOwner: TComponent); override;
  published
  end;

  TmwComboStrGrid = class(TCustomEdit)
    Box: TSpeedButton;
    Grid: TStringGrid;
    procedure BoxClick(Sender: TObject);
  private
    FCanvas: TControlCanvas;
    fImage: TBitmap;
    fStateImage: TBitmap;
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
    procedure WndProc(var Message: TMessage); override;
    procedure SetStateImage(NewValue: TBitmap);
    procedure SetImage(NewValue: TBitmap);
    function GetBoxWidth: Integer;
    procedure SetBoxWidth(NewValue: Integer);
    function GetBoxGlyph: TBitmap;
    procedure SetBoxGlyph(NewValue: TBitmap);
    function GetGridHeight: Integer;
    procedure SetGridHeight(NewValue: Integer);
    procedure SetGridColCount(NewValue:Longint);
    function GetGridColCount:Longint;
    procedure SetGridColor(newValue: TColor);
    function GetGridColor: TColor;
    procedure SetGridCtl3D(newValue: Boolean);
    function GetGridCtl3D: Boolean;
    procedure SetGridCursor(newValue: TCursor);
    function GetGridCursor: TCursor;
    procedure SetGridDefaultColWidth(newValue: Integer);
    function GetGridDefaultColWidth: Integer;
    procedure SetGridDefaultDrawing(newValue: Boolean);
    function GetGridDefaultDrawing: Boolean;
    procedure SetGridDefaultRowHeight(newValue: Integer);
    function GetGridDefaultRowHeight: Integer;
    procedure SetGridDragCursor(newValue: TCursor);
    function GetGridDragCursor: TCursor;
    procedure SetGridDragMode(newValue: TDragMode);
    function GetGridDragMode: TDragMode;
    procedure SetGridEnabled(newValue: Boolean);
    function GetGridEnabled: Boolean;
    procedure SetGridFixedColor(newValue: TColor);
    function GetGridFixedColor: TColor;
    procedure SetGridFixedCols(newValue: Integer);
    function GetGridFixedCols: Integer;
    procedure SetGridFixedRows(newValue: Integer);
    function GetGridFixedRows: Integer;
    procedure SetGridFont(newValue: TFont);
    function GetGridFont: TFont;
    procedure SetGridGridLineWidth(newValue: Integer);
    function GetGridGridLineWidth: Integer;
    procedure SetGridHelpContext(newValue: THelpContext);
    function GetGridHelpContext: THelpContext;
    procedure SetGridHint(newValue: string);
    function GetGridHint: string;
    procedure SetGridOptions(newValue: TGridOptions);
    function GetGridOptions: TGridOptions;
    procedure SetGridParentColor(newValue: Boolean);
    function GetGridParentColor: Boolean;
    procedure SetGridParentCtl3D(newValue: Boolean);
    function GetGridParentCtl3D: Boolean;
    procedure SetGridParentFont(newValue: Boolean);
    function GetGridParentFont: Boolean;
    procedure SetGridParentShowHint(newValue: Boolean);
    function GetGridParentShowHint: Boolean;
    procedure SetGridPopupMenu(newValue: TPopupMenu);
    function GetGridPopupMenu: TPopupMenu;
    procedure SetGridRowCount(newValue: Longint);
    function GetGridRowCount: Longint;
    procedure SetGridScrollBars(newValue: TScrollStyle);
    function GetGridScrollBars: TScrollStyle;
    procedure SetGridShowHint(newValue: Boolean);
    function GetGridShowHint: Boolean;
    procedure SetGridTabOrder(newValue: TTabOrder);
    function GetGridTabOrder: TTabOrder;
    procedure SetGridTabStop(newValue: Boolean);
    function GetGridTabStop: Boolean;
    procedure SetGridTag(newValue: Longint);
    function GetGridTag: Longint;
    procedure SetGridVisible(newValue: Boolean);
    function GetGridVisible: Boolean;
    function GetGridVisibleColCount: Integer;
    function GetGridVisibleRowCount: Integer;
    Function GetGridOnClick: TNotifyEvent;
    Procedure PutGridOnClick(value: TNotifyEvent);
    Function GetGridOnColumnMoved: TMovedEvent;
    Procedure PutGridOnColumnMoved(value: TMovedEvent);
    Function GetGridOnDblClick: TNotifyEvent;
    Procedure PutGridOnDblClick(value: TNotifyEvent);
    Function GetGridOnDragDrop: TDragDropEvent;
    Procedure PutGridOnDragDrop(value: TDragDropEvent);
    Function GetGridOnDragOver: TDragOverEvent;
    Procedure PutGridOnDragOver(value: TDragOverEvent);
    Function GetGridOnDrawCell: TDrawCellEvent;
    Procedure PutGridOnDrawCell(value: TDrawCellEvent);
    Function GetGridOnEndDrag: TEndDragEvent;
    Procedure PutGridOnEndDrag(value: TEndDragEvent);
    Function GetGridOnEnter: TNotifyEvent;
    Procedure PutGridOnEnter(value: TNotifyEvent);
    Function GetGridOnExit: TNotifyEvent;
    Procedure PutGridOnExit(value: TNotifyEvent);
    Function GetGridOnGetEditMask: TGetEditEvent;
    Procedure PutGridOnGetEditMask(value: TGetEditEvent);
    Function GetGridOnGetEditText: TGetEditEvent;
    Procedure PutGridOnGetEditText(value: TGetEditEvent);
    Function GetGridOnKeyDown: TKeyEvent;
    Procedure PutGridOnKeyDown(value: TKeyEvent);
    Function GetGridOnKeyPress: TKeyPressEvent;
    Procedure PutGridOnKeyPress(value: TKeyPressEvent);
    Function GetGridOnKeyUp: TKeyEvent;
    Procedure PutGridOnKeyUp(value: TKeyEvent);
    Function GetGridOnMouseDown: TMouseEvent;
    Procedure PutGridOnMouseDown(value: TMouseEvent);
    Function GetGridOnMouseMove: TMouseMoveEvent;
    Procedure PutGridOnMouseMove(value: TMouseMoveEvent);
    Function GetGridOnMouseUp: TMouseEvent;
    Procedure PutGridOnMouseUp(value: TMouseEvent);
    Function GetGridOnRowMoved: TMovedEvent;
    Procedure PutGridOnRowMoved(value: TMovedEvent);
    Function GetGridOnSelectCell: TSelectCellEvent;
    Procedure PutGridOnSelectCell(value: TSelectCellEvent);
    Function GetGridOnSetEditText: TSetEditEvent;
    Procedure PutGridOnSetEditText(value: TSetEditEvent);
    Function GetGridOnStartDrag: TStartDragEvent;
    Procedure PutGridOnStartDrag(value: TStartDragEvent);
    function GetGridOnTopLeftChanged:TNotifyEvent;
    procedure PutGridOnTopLeftChanged(NewValue:TNotifyEvent);
  protected
    procedure CreateWindowHandle(const Params: TCreateParams); override;
    procedure SetEditRect;
    procedure SetBounds(Left, Top, Width, Height: Integer); override;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure DrawImage(Bitmap: TBitmap; Position: Integer);
  published
    property Font;
    property Text;
    property Image: TBitmap read fImage write SetImage;
    property StateImage: TBitmap read fStateImage write SetStateImage;
    property BoxWidth: Integer read GetBoxWidth write SetBoxWidth;
    property BoxGlyph: TBitmap read GetBoxGlyph write SetBoxGlyph;
    property GridHeight: Integer read GetGridHeight write SetGridHeight;
    property GridColCount:Longint read GetGridColCount write SetGridColCount;
    property GridColor: TColor read GetGridColor write SetGridColor;
    property GridCtl3D: Boolean read GetGridCtl3D write SetGridCtl3D;
    property GridCursor: TCursor read GetGridCursor write SetGridCursor;
    property GridDefaultColWidth: Integer read GetGridDefaultColWidth write SetGridDefaultColWidth;
    property GridDefaultDrawing: Boolean read GetGridDefaultDrawing write SetGridDefaultDrawing;
    property GridDefaultRowHeight: Integer read GetGridDefaultRowHeight write SetGridDefaultRowHeight;
    property GridDragCursor: TCursor read GetGridDragCursor write SetGridDragCursor;
    property GridDragMode: TDragMode read GetGridDragMode write SetGridDragMode;
    property GridEnabled: Boolean read GetGridEnabled write SetGridEnabled;
    property GridFixedColor: TColor read GetGridFixedColor write SetGridFixedColor;
    property GridFixedCols: Integer read GetGridFixedCols write SetGridFixedCols;
    property GridFixedRows: Integer read GetGridFixedRows write SetGridFixedRows;
    property GridFont: TFont read GetGridFont write SetGridFont;
    property GridGridLineWidth: Integer read GetGridGridLineWidth write SetGridGridLineWidth;
    property GridHelpContext: THelpContext read GetGridHelpContext write SetGridHelpContext;
    property GridHint: string read GetGridHint write SetGridHint;
    property GridOptions: TGridOptions read GetGridOptions write SetGridOptions;
    property GridParentColor: Boolean read GetGridParentColor write SetGridParentColor;
    property GridParentCtl3D: Boolean read GetGridParentCtl3D write SetGridParentCtl3D;
    property GridParentFont: Boolean read GetGridParentFont write SetGridParentFont;
    property GridParentShowHint: Boolean read GetGridParentShowHint write SetGridParentShowHint;
    property GridPopupMenu: TPopupMenu read GetGridPopupMenu write SetGridPopupMenu;
    property GridRowCount: Longint read GetGridRowCount write SetGridRowCount;
    property GridScrollBars: TScrollStyle read GetGridScrollBars write SetGridScrollBars;
    property GridShowHint: Boolean read GetGridShowHint write SetGridShowHint;
    property GridTabOrder: TTabOrder read GetGridTabOrder write SetGridTabOrder;
    property GridTabStop: Boolean read GetGridTabStop write SetGridTabStop;
    property GridTag: Longint read GetGridTag write SetGridTag;
    property GridVisible: Boolean read GetGridVisible write SetGridVisible;
    property GridVisibleColCount: Integer read GetGridVisibleColCount;
    property GridVisibleRowCount: Integer read GetGridVisibleRowCount;
    property ShowHint;
    property OnChange;
    property OnClick;
    property OnDblClick;
    property OnEnter;
    property OnExit;
    property GridOnTopLeftChanged:TNotifyEvent read GetGridOnTopLeftChanged write PutGridOnTopLeftChanged;
    property GridOnStartDrag: TStartDragEvent read GetGridOnStartDrag write PutGridOnStartDrag;
    property GridOnSetEditText: TSetEditEvent read GetGridOnSetEditText write PutGridOnSetEditText;
    property GridOnSelectCell: TSelectCellEvent read GetGridOnSelectCell write PutGridOnSelectCell;
    property GridOnRowMoved: TMovedEvent read GetGridOnRowMoved write PutGridOnRowMoved;
    property GridOnMouseUp: TMouseEvent read GetGridOnMouseUp write PutGridOnMouseUp;
    property GridOnMouseMove: TMouseMoveEvent read GetGridOnMouseMove write PutGridOnMouseMove;
    property GridOnMouseDown: TMouseEvent read GetGridOnMouseDown write PutGridOnMouseDown;
    property GridOnKeyUp: TKeyEvent read GetGridOnKeyUp write PutGridOnKeyUp;
    property GridOnKeyPress: TKeyPressEvent read GetGridOnKeyPress write PutGridOnKeyPress;
    property GridOnKeyDown: TKeyEvent read GetGridOnKeyDown write PutGridOnKeyDown;
    property GridOnGetEditText: TGetEditEvent read GetGridOnGetEditText write PutGridOnGetEditText;
    property GridOnGetEditMask: TGetEditEvent read GetGridOnGetEditMask write PutGridOnGetEditMask;
    property GridOnExit: TNotifyEvent read GetGridOnExit write PutGridOnExit;
    property GridOnEnter: TNotifyEvent read GetGridOnEnter write PutGridOnEnter;
    property GridOnEndDrag: TEndDragEvent read GetGridOnEndDrag write PutGridOnEndDrag;
    property GridOnDrawCell: TDrawCellEvent read GetGridOnDrawCell write PutGridOnDrawCell;
    property GridOnDragOver: TDragOverEvent read GetGridOnDragOver write PutGridOnDragOver;
    property GridOnDragDrop: TDragDropEvent read GetGridOnDragDrop write PutGridOnDragDrop;
    property GridOnDblClick: TNotifyEvent read GetGridOnDblClick write PutGridOnDblClick;
    property GridOnColumnMoved: TMovedEvent read GetGridOnColumnMoved write PutGridOnColumnMoved;
    property GridOnClick: TNotifyEvent read GetGridOnClick write PutGridOnClick;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('mw', [TmwComboStrGrid]);
end; { Register }

constructor TmwScreenStrGrid.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Enabled := False;
  Visible := False;
end; { Create }

procedure TmwScreenStrGrid.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  with Params do
  begin Style := Style or WS_BORDER; ExStyle := WS_EX_TOOLWINDOW or
    WS_EX_TOPMOST; WindowClass.Style := CS_SAVEBITS;
  end;
end; { CreateParams }

procedure TmwScreenStrGrid.CreateWnd;
begin
  inherited CreateWnd;
  Windows.SetParent(Handle, 0); CallWindowProc(DefWndProc, Handle, wm_SetFocus, 0, 0);
end; { CreateWnd }

procedure TmwScreenStrGrid.CMMouseEnter(var Message: TMessage);
begin
  inherited;
  FMouseInControl := True;
  ReleaseCapture;
end; { CMMouseEnter }

procedure TmwScreenStrGrid.CMMouseLeave(var Message: TMessage);
begin
  inherited;
  FMouseInControl := False;
  SetCaptureControl(Self);
end; { CMMouseLeave }

procedure TmwScreenStrGrid.WMMouseMove(var Message: TWMMouseMove);
begin
  inherited;
end; { WMMouseMove }

procedure TmwScreenStrGrid.WMLButtonDown(var Message: TWMLButtonDown);
begin
  inherited;
  Case FMouseInControl of
    False:
      begin
        ReleaseCapture;
        Enabled := False;
        Visible := False;
      end;
    True:
      begin
        SendMessage((Owner.Owner as TWinControl).Handle, WM_LBUTTONDOWN, 0, 0);
      end;
  end;
end; { WMLButtonDown }

destructor TmwComboStrGrid.Destroy;
begin
  FCanvas.Free;
  inherited Destroy;
  FImage.free;
  FStateImage.free;
end; { Destroy }

constructor TmwComboStrGrid.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Width := 241;
  Height := 21;
  TabOrder := 0;

  FCanvas := TControlCanvas.Create;
  FCanvas.Control := Self;

  Box := TSpeedButton.Create(Self);
  Box.Parent := Self;

  FImage := TBitmap.Create;
  FImage.Transparent := True;
  FStateImage := TBitmap.Create;
  FStateImage.Transparent := True;

  Grid := TmwScreenStrGrid.Create(Self);
  Grid.Parent := Self;
end; { Create }

procedure TmwComboStrGrid.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or ES_MULTILINE or WS_CLIPCHILDREN;
end;

procedure TmwComboStrGrid.CreateWnd;
begin
  inherited CreateWnd;
  SetEditRect;
end; { CreateWnd }

procedure TmwComboStrGrid.CreateWindowHandle(const Params: TCreateParams);
begin
  inherited CreateWindowHandle(Params);

  with Box do
  begin
    Left := 220;
    Top := 0;
    Width := 17;
    Height := 17;
    Cursor := crArrow;
    OnClick := BoxClick;
  end; { Box }

  with Grid do
  begin
    Left := 0;
    Top := 0;
    Width := 0;
    Height := 120;
  end; { Grid }

end; { CreateWindowHandle }

procedure TmwComboStrGrid.WMPaint(var Message: TWMPaint);
begin
  inherited PaintHandler(Message);
  if not FStateImage.Empty and not FImage.Empty then
  begin
    DrawImage(FStateImage, 3);
    DrawImage(FImage, FStateImage.Width + 6);
  end else
    if not FStateImage.Empty and FImage.Empty then
    begin
      DrawImage(FStateImage, 3);
    end else
      if FStateImage.Empty and not FImage.Empty then
      begin
        DrawImage(FImage, 3);
      end;
end; { WMPaint }

procedure TmwComboStrGrid.WndProc(var Message: TMessage);
begin
  with Message do
    case Msg of
      WM_WINDOWPOSCHANGING: SetEditRect;
    end;
  inherited WndProc(Message);
end; { WndProc }

procedure TmwComboStrGrid.SetEditRect;
var
  Loc: TRect;
begin
  if not FStateImage.Empty and not FImage.Empty then
  begin
    SetRect(Loc, FStateImage.Width + FImage.Width + 9, 0, ClientWidth - Box.Width - 2, ClientHeight + 1);
    SendMessage(Handle, EM_SETRECTNP, 0, LongInt(@Loc));
  end else
    if not FStateImage.Empty and FImage.Empty then
    begin
      SetRect(Loc, FStateImage.Width + 6, 0, ClientWidth - Box.Width - 2, ClientHeight + 1);
      SendMessage(Handle, EM_SETRECTNP, 0, LongInt(@Loc));
    end else
      if FStateImage.Empty and not FImage.Empty then
      begin
        SetRect(Loc, FImage.Width + 6, 0, ClientWidth - Box.Width - 2, ClientHeight + 1);
        SendMessage(Handle, EM_SETRECTNP, 0, LongInt(@Loc));
      end else
        if FStateImage.Empty and FImage.Empty then
        begin
          SetRect(Loc, 0, 0, ClientWidth - Box.Width - 2, ClientHeight + 1);
          SendMessage(Handle, EM_SETRECTNP, 0, LongInt(@Loc));
        end;
end;

procedure TmwComboStrGrid.BoxClick(Sender: TObject);
var
  CP, SP: TPoint;
begin
  CP.X := Left;
  CP.Y := Top + Height;
  SP := (Owner as TForm).ClientToScreen(CP);

  with Grid do
  begin
    Left := SP.X;
    Top := SP.Y;
    Width := Self.Width;
    Enabled := True;
    Visible := True;
  end; { Grid }
  SetCaptureControl(Grid);
end; { BoxClick }

procedure TmwComboStrGrid.SetBounds(Left, Top, Width, Height: Integer);
begin
  Case Parent <> nil of
    True:
      begin
        inherited SetBounds(Left, Top, Width, Height);
        with Box do
        begin
          Left := Self.Width - Box.Width - 4;
          Height := Self.Height - 4;
        end;
        SetEditRect;
      end;
    False: inherited SetBounds(Left, Top, Width, Height);
  end;
end; { SetBounds }

procedure TmwComboStrGrid.DrawImage(Bitmap: TBitmap; Position: Integer);
var
  YPos: Integer;
begin
  YPos := ClientHeight div 2 - 7;
  FCanvas.Draw(Position, YPos, Bitmap);
end; { DrawImage }

procedure TmwComboStrGrid.SetImage(NewValue: TBitmap);
begin
  FImage.Assign(NewValue);
  FImage.Transparent := True;
  SetEditRect;
  RePaint;
end; { SetImage }

procedure TmwComboStrGrid.SetStateImage(NewValue: TBitmap);
begin
  FStateImage.Assign(NewValue);
  FStateImage.Transparent := True;
  SetEditRect;
  RePaint;
end; { SetStateImage }

function TmwComboStrGrid.GetBoxWidth: Integer;
begin
  GetBoxWidth := Box.Width;
end; { GetBoxWidth }

procedure TmwComboStrGrid.SetBoxWidth(NewValue: Integer);
begin
  Box.Width := NewValue;
  Box.Left := ClientWidth - Box.Width;
  SetEditRect;
end; { SetBoxWidth }

function TmwComboStrGrid.GetBoxGlyph: TBitmap;
begin
  GetBoxGlyph := Box.Glyph;
end; { GetBoxGlyph }

procedure TmwComboStrGrid.SetBoxGlyph(NewValue: TBitmap);
begin
  Box.Glyph := NewValue;
end; { SetBoxGlyph }

function TmwComboStrGrid.GetGridHeight: Integer;
begin
  GetGridHeight := Grid.Height;
end; { GetGridHeight }

procedure TmwComboStrGrid.SetGridHeight(NewValue: Integer);
begin
  Grid.Height := NewValue;
end; { SetGridHeight }

procedure TmwComboStrGrid.SetGridColCount(NewValue:Longint);
begin
  Grid.ColCount := newValue;
end; { SetGridColCount }

function TmwComboStrGrid.GetGridColCount:Longint;
begin
  GetGridColCount := Grid.ColCount;
end; { GetGridColCount }

procedure TmwComboStrGrid.SetGridColor(newValue: TColor);
begin
  Grid.Color := newValue;
end; { SetGridColor }

function TmwComboStrGrid.GetGridColor: TColor;
begin
  GetGridColor := Grid.Color;
end; { GetGridColor }

procedure TmwComboStrGrid.SetGridCtl3D(newValue: Boolean);
begin
  Grid.Ctl3D := newValue;
end; { SetGridCtl3D }

function TmwComboStrGrid.GetGridCtl3D: Boolean;
begin
  GetGridCtl3D := Grid.Ctl3D;
end; { GetGridCtl3D }

procedure TmwComboStrGrid.SetGridCursor(newValue: TCursor);
begin
  Grid.Cursor := newValue;
end; { SetGridCursor }

function TmwComboStrGrid.GetGridCursor: TCursor;
begin
  GetGridCursor := Grid.Cursor;
end; { GetGridCursor }

procedure TmwComboStrGrid.SetGridDefaultColWidth(newValue: Integer);
begin
  Grid.DefaultColWidth := newValue;
end; { SetGridDefaultColWidth }

function TmwComboStrGrid.GetGridDefaultColWidth: Integer;
begin
  GetGridDefaultColWidth := Grid.DefaultColWidth;
end; { GetGridDefaultColWidth }

procedure TmwComboStrGrid.SetGridDefaultDrawing(newValue: Boolean);
begin
  Grid.DefaultDrawing := newValue;
end; { SetGridDefaultDrawing }

function TmwComboStrGrid.GetGridDefaultDrawing: Boolean;
begin
  GetGridDefaultDrawing := Grid.DefaultDrawing;
end; { GetGridDefaultDrawing }

procedure TmwComboStrGrid.SetGridDefaultRowHeight(newValue: Integer);
begin
  Grid.DefaultRowHeight := newValue;
end; { SetGridDefaultRowHeight }

function TmwComboStrGrid.GetGridDefaultRowHeight: Integer;
begin
  GetGridDefaultRowHeight := Grid.DefaultRowHeight;
end; { GetGridDefaultRowHeight }

procedure TmwComboStrGrid.SetGridDragCursor(newValue: TCursor);
begin
  Grid.DragCursor := newValue;
end; { SetGridDragCursor }

function TmwComboStrGrid.GetGridDragCursor: TCursor;
begin
  GetGridDragCursor := Grid.DragCursor;
end; { GetGridDragCursor }

procedure TmwComboStrGrid.SetGridDragMode(newValue: TDragMode);
begin
  Grid.DragMode := newValue;
end; { SetGridDragMode }

function TmwComboStrGrid.GetGridDragMode: TDragMode;
begin
  GetGridDragMode := Grid.DragMode;
end; { GetGridDragMode }

procedure TmwComboStrGrid.SetGridEnabled(newValue: Boolean);
begin
  Grid.Enabled := newValue;
end; { SetGridEnabled }

function TmwComboStrGrid.GetGridEnabled: Boolean;
begin
  GetGridEnabled := Grid.Enabled;
end; { GetGridEnabled }

procedure TmwComboStrGrid.SetGridFixedColor(newValue: TColor);
begin
  Grid.FixedColor := newValue;
end; { SetGridFixedColor }

function TmwComboStrGrid.GetGridFixedColor: TColor;
begin
  GetGridFixedColor := Grid.FixedColor;
end; { GetGridFixedColor }

procedure TmwComboStrGrid.SetGridFixedCols(newValue: Integer);
begin
  Grid.FixedCols := newValue;
end; { SetGridFixedCols }

function TmwComboStrGrid.GetGridFixedCols: Integer;
begin
  GetGridFixedCols := Grid.FixedCols;
end; { GetGridFixedCols }

procedure TmwComboStrGrid.SetGridFixedRows(newValue: Integer);
begin
  Grid.FixedRows := newValue;
end; { SetGridFixedRows }

function TmwComboStrGrid.GetGridFixedRows: Integer;
begin
  GetGridFixedRows := Grid.FixedRows;
end; { GetGridFixedRows }

procedure TmwComboStrGrid.SetGridFont(newValue: TFont);
begin
  Grid.Font := newValue;
end; { SetGridFont }

function TmwComboStrGrid.GetGridFont: TFont;
begin
  GetGridFont := Grid.Font;
end; { GetGridFont }

procedure TmwComboStrGrid.SetGridGridLineWidth(newValue: Integer);
begin
  Grid.GridLineWidth := newValue;
end; { SetGridGridLineWidth }

function TmwComboStrGrid.GetGridGridLineWidth: Integer;
begin
  GetGridGridLineWidth := Grid.GridLineWidth;
end; { GetGridGridLineWidth }

procedure TmwComboStrGrid.SetGridHelpContext(newValue: THelpContext);
begin
  Grid.HelpContext := newValue;
end; { SetGridHelpContext }

function TmwComboStrGrid.GetGridHelpContext: THelpContext;
begin
  GetGridHelpContext := Grid.HelpContext;
end; { GetGridHelpContext }

procedure TmwComboStrGrid.SetGridHint(newValue: string);
begin
  Grid.Hint := newValue;
end; { SetGridHint }

function TmwComboStrGrid.GetGridHint: string;
begin
  GetGridHint := Grid.Hint;
end; { GetGridHint }

procedure TmwComboStrGrid.SetGridOptions(newValue: TGridOptions);
begin
  Grid.Options := newValue;
end; { SetGridOptions }

function TmwComboStrGrid.GetGridOptions: TGridOptions;
begin
  GetGridOptions := Grid.Options;
end; { GetGridOptions }

procedure TmwComboStrGrid.SetGridParentColor(newValue: Boolean);
begin
  Grid.ParentColor := newValue;
end; { SetGridParentColor }

function TmwComboStrGrid.GetGridParentColor: Boolean;
begin
  GetGridParentColor := Grid.ParentColor;
end; { GetGridParentColor }

procedure TmwComboStrGrid.SetGridParentCtl3D(newValue: Boolean);
begin
  Grid.ParentCtl3D := newValue;
end; { SetGridParentCtl3D }

function TmwComboStrGrid.GetGridParentCtl3D: Boolean;
begin
  GetGridParentCtl3D := Grid.ParentCtl3D;
end; { GetGridParentCtl3D }

procedure TmwComboStrGrid.SetGridParentFont(newValue: Boolean);
begin
  Grid.ParentFont := newValue;
end; { SetGridParentFont }

function TmwComboStrGrid.GetGridParentFont: Boolean;
begin
  GetGridParentFont := Grid.ParentFont;
end; { GetGridParentFont }

procedure TmwComboStrGrid.SetGridParentShowHint(newValue: Boolean);
begin
  Grid.ParentShowHint := newValue;
end; { SetGridParentShowHint }

function TmwComboStrGrid.GetGridParentShowHint: Boolean;
begin
  GetGridParentShowHint := Grid.ParentShowHint;
end; { GetGridParentShowHint }

procedure TmwComboStrGrid.SetGridPopupMenu(newValue: TPopupMenu);
begin
  Grid.PopupMenu := newValue;
end; { SetGridPopupMenu }

function TmwComboStrGrid.GetGridPopupMenu: TPopupMenu;
begin
  GetGridPopupMenu := Grid.PopupMenu;
end; { GetGridPopupMenu }

procedure TmwComboStrGrid.SetGridRowCount(newValue: Longint);
begin
  Grid.RowCount := newValue;
end; { SetGridRowCount }

function TmwComboStrGrid.GetGridRowCount: Longint;
begin
  GetGridRowCount := Grid.RowCount;
end; { GetGridRowCount }

procedure TmwComboStrGrid.SetGridScrollBars(newValue: TScrollStyle);
begin
  Grid.ScrollBars := newValue;
end; { SetGridScrollBars }

function TmwComboStrGrid.GetGridScrollBars: TScrollStyle;
begin
  GetGridScrollBars := Grid.ScrollBars;
end; { GetGridScrollBars }

procedure TmwComboStrGrid.SetGridShowHint(newValue: Boolean);
begin
  Grid.ShowHint := newValue;
end; { SetGridShowHint }

function TmwComboStrGrid.GetGridShowHint: Boolean;
begin
  GetGridShowHint := Grid.ShowHint;
end; { GetGridShowHint }

procedure TmwComboStrGrid.SetGridTabOrder(newValue: TTabOrder);
begin
  Grid.TabOrder := newValue;
end; { SetGridTabOrder }

function TmwComboStrGrid.GetGridTabOrder: TTabOrder;
begin
  GetGridTabOrder := Grid.TabOrder;
end; { GetGridTabOrder }

procedure TmwComboStrGrid.SetGridTabStop(newValue: Boolean);
begin
  Grid.TabStop := newValue;
end; { SetGridTabStop }

function TmwComboStrGrid.GetGridTabStop: Boolean;
begin
  GetGridTabStop := Grid.TabStop;
end; { GetGridTabStop }

procedure TmwComboStrGrid.SetGridTag(newValue: Longint);
begin
  Grid.Tag := newValue;
end; { SetGridTag }

function TmwComboStrGrid.GetGridTag: Longint;
begin
  GetGridTag := Grid.Tag;
end; { GetGridTag }

procedure TmwComboStrGrid.SetGridVisible(newValue: Boolean);
begin
  Grid.Visible := newValue;
end; { SetGridVisible }

function TmwComboStrGrid.GetGridVisible: Boolean;
begin
  GetGridVisible := Grid.Visible;
end; { GetGridVisible }

function TmwComboStrGrid.GetGridVisibleColCount: Integer;
begin
  GetGridVisibleColCount := Grid.VisibleColCount;
end; { GetGridVisibleColCount }

function TmwComboStrGrid.GetGridVisibleRowCount: Integer;
begin
  GetGridVisibleRowCount := Grid.VisibleRowCount;
end; { GetGridVisibleRowCount }

Function TmwComboStrGrid.GetGridOnClick: TNotifyEvent;
begin
  result := Grid.OnClick;
end;

Procedure TmwComboStrGrid.PutGridOnClick(value: TNotifyEvent);
begin
  Grid.OnClick := value;
end;

Function TmwComboStrGrid.GetGridOnColumnMoved: TMovedEvent;
begin
  result := Grid.OnColumnMoved;
end;

Procedure TmwComboStrGrid.PutGridOnColumnMoved(value: TMovedEvent);
begin
  Grid.OnColumnMoved := value;
end;

Function TmwComboStrGrid.GetGridOnDblClick: TNotifyEvent;
begin
  result := Grid.OnDblClick;
end;

Procedure TmwComboStrGrid.PutGridOnDblClick(value: TNotifyEvent);
begin
  Grid.OnDblClick := value;
end;

Function TmwComboStrGrid.GetGridOnDragDrop: TDragDropEvent;
begin
  result := Grid.OnDragDrop;
end;

Procedure TmwComboStrGrid.PutGridOnDragDrop(value: TDragDropEvent);
begin
  Grid.OnDragDrop := value;
end;

Function TmwComboStrGrid.GetGridOnDragOver: TDragOverEvent;
begin
  result := Grid.OnDragOver;
end;

Procedure TmwComboStrGrid.PutGridOnDragOver(value: TDragOverEvent);
begin
  Grid.OnDragOver := value;
end;

Function TmwComboStrGrid.GetGridOnDrawCell: TDrawCellEvent;
begin
  result := Grid.OnDrawCell;
end;

Procedure TmwComboStrGrid.PutGridOnDrawCell(value: TDrawCellEvent);
begin
  Grid.OnDrawCell := value;
end;

Function TmwComboStrGrid.GetGridOnEndDrag: TEndDragEvent;
begin
  result := Grid.OnEndDrag;
end;

Procedure TmwComboStrGrid.PutGridOnEndDrag(value: TEndDragEvent);
begin
  Grid.OnEndDrag := value;
end;

Function TmwComboStrGrid.GetGridOnEnter: TNotifyEvent;
begin
  result := Grid.OnEnter;
end;

Procedure TmwComboStrGrid.PutGridOnEnter(value: TNotifyEvent);
begin
  Grid.OnEnter := value;
end;

Function TmwComboStrGrid.GetGridOnExit: TNotifyEvent;
begin
  result := Grid.OnExit;
end;

Procedure TmwComboStrGrid.PutGridOnExit(value: TNotifyEvent);
begin
  Grid.OnExit := value;
end;

Function TmwComboStrGrid.GetGridOnGetEditMask: TGetEditEvent;
begin
  result := Grid.OnGetEditMask;
end;

Procedure TmwComboStrGrid.PutGridOnGetEditMask(value: TGetEditEvent);
begin
  Grid.OnGetEditMask := value;
end;

Function TmwComboStrGrid.GetGridOnGetEditText: TGetEditEvent;
begin
  result := Grid.OnGetEditText;
end;

Procedure TmwComboStrGrid.PutGridOnGetEditText(value: TGetEditEvent);
begin
  Grid.OnGetEditText := value;
end;

Function TmwComboStrGrid.GetGridOnKeyDown: TKeyEvent;
begin
  result := Grid.OnKeyDown;
end;

Procedure TmwComboStrGrid.PutGridOnKeyDown(value: TKeyEvent);
begin
  Grid.OnKeyDown := value;
end;

Function TmwComboStrGrid.GetGridOnKeyPress: TKeyPressEvent;
begin
  result := Grid.OnKeyPress;
end;

Procedure TmwComboStrGrid.PutGridOnKeyPress(value: TKeyPressEvent);
begin
  Grid.OnKeyPress := value;
end;

Function TmwComboStrGrid.GetGridOnKeyUp: TKeyEvent;
begin
  result := Grid.OnKeyUp;
end;

Procedure TmwComboStrGrid.PutGridOnKeyUp(value: TKeyEvent);
begin
  Grid.OnKeyUp := value;
end;

Function TmwComboStrGrid.GetGridOnMouseDown: TMouseEvent;
begin
  result := Grid.OnMouseDown;
end;

Procedure TmwComboStrGrid.PutGridOnMouseDown(value: TMouseEvent);
begin
  Grid.OnMouseDown := value;
end;

Function TmwComboStrGrid.GetGridOnMouseMove: TMouseMoveEvent;
begin
  result := Grid.OnMouseMove;
end;

Procedure TmwComboStrGrid.PutGridOnMouseMove(value: TMouseMoveEvent);
begin
  Grid.OnMouseMove := value;
end;

Function TmwComboStrGrid.GetGridOnMouseUp: TMouseEvent;
begin
  result := Grid.OnMouseUp;
end;

Procedure TmwComboStrGrid.PutGridOnMouseUp(value: TMouseEvent);
begin
  Grid.OnMouseUp := value;
end;

Function TmwComboStrGrid.GetGridOnRowMoved: TMovedEvent;
begin
  result := Grid.OnRowMoved;
end;

Procedure TmwComboStrGrid.PutGridOnRowMoved(value: TMovedEvent);
begin
  Grid.OnRowMoved := value;
end;

Function TmwComboStrGrid.GetGridOnSelectCell: TSelectCellEvent;
begin
  result := Grid.OnSelectCell;
end;

Procedure TmwComboStrGrid.PutGridOnSelectCell(value: TSelectCellEvent);
begin
  Grid.OnSelectCell := value;
end;

Function TmwComboStrGrid.GetGridOnSetEditText: TSetEditEvent;
begin
  result := Grid.OnSetEditText;
end;

Procedure TmwComboStrGrid.PutGridOnSetEditText(value: TSetEditEvent);
begin
  Grid.OnSetEditText := value;
end;

Function TmwComboStrGrid.GetGridOnStartDrag: TStartDragEvent;
begin
  result := Grid.OnStartDrag;
end;

Procedure TmwComboStrGrid.PutGridOnStartDrag(value: TStartDragEvent);
begin
  Grid.OnStartDrag := value;
end;

function TmwComboStrGrid.GetGridOnTopLeftChanged:TNotifyEvent;
begin
  result := Grid.OnTopLeftChanged;
end;

procedure TmwComboStrGrid.PutGridOnTopLeftChanged(NewValue:TNotifyEvent);
begin
  Grid.OnTopLeftChanged := NewValue;
end;

end.

